%define anolis_release 2
%define rsyslog_statedir %{_sharedstatedir}/rsyslog
%define rsyslog_pkidir %{_sysconfdir}/pki/rsyslog
%define rsyslog_docdir %{_docdir}/rsyslog

Summary: Enhanced system logging and kernel message trapping daemon
Name: rsyslog
Version: 8.2212.0
Release: %{anolis_release}%{?dist}
License: (GPLv3+ and ASL 2.0)
URL: http://www.rsyslog.com/
Source0: http://www.rsyslog.com/files/download/rsyslog/%{name}-%{version}.tar.gz
Source1: http://www.rsyslog.com/files/download/rsyslog/%{name}-doc-%{version}.tar.gz
Source2: rsyslog.conf
Source3: rsyslog.sysconfig
Source4: rsyslog.log
Source5: rsyslog.service
# Add qpid-proton as another source, enable omamqp1 module in a
# separatae sub-package with it statically linked(see rhbz#1713427)
Source6: qpid-proton-0.34.0.tar.gz

Patch0: openssl3-compatibility.patch
Patch1: rsyslog-8.2210.0-rhbz2127403-drop-capabilities.patch

BuildRequires: make
BuildRequires: gcc
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: bison
BuildRequires: dos2unix
BuildRequires: flex
BuildRequires: libgcrypt-devel
BuildRequires: libfastjson-devel >= 0.99.8
BuildRequires: libestr-devel >= 0.1.9
BuildRequires: libtool
BuildRequires: libuuid-devel
BuildRequires: pkgconfig
BuildRequires: python3-docutils
# make sure systemd is in a version that isn't affected by rhbz#974132
BuildRequires: systemd-devel >= 204-8
BuildRequires: systemd-rpm-macros
BuildRequires: zlib-devel
BuildRequires: libcap-ng-devel

Recommends: %{name}-logrotate = %{version}-%{release}
Requires: bash >= 2.0
%{?systemd_ordering}

Provides: syslog
Obsoletes: sysklogd < 1.5-11

%package logrotate
Summary: Log rotation for rsyslog
Requires: %{name} = %{version}-%{release}
Requires: logrotate >= 3.5.2

%package crypto
Summary: Encryption support
Requires: %{name} = %{version}-%{release}

%package doc
Summary: HTML documentation for rsyslog
BuildArch: noarch
Requires: %{name} = %{version}-%{release}

%package elasticsearch
Summary: ElasticSearch output module for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: libcurl-devel

%package mmjsonparse
Summary: JSON enhanced logging support
Requires: %{name} = %{version}-%{release}

%package mmnormalize
Summary: Log normalization support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: libestr-devel liblognorm-devel >= 1.0.2

%package mmaudit
Summary: Message modification module supporting Linux audit format
Requires: %{name} = %{version}-%{release}

%package mmfields
Summary: Fields extraction module
Requires: %{name} = %{version}-%{release}

%package mmsnmptrapd
Summary: Message modification module for snmptrapd generated messages
Requires: %{name} = %{version}-%{release}

%package mysql
Summary: MySQL support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: mariadb-connector-c-devel

%package pgsql
Summary: PostgresSQL support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: libpq-devel

%package gssapi
Summary: GSSAPI authentication and encryption support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: krb5-devel

%package relp
Summary: RELP protocol support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: librelp-devel >= 1.2.16

%package gnutls
Summary: TLS protocol support for rsyslog via GnuTLS library
Requires: %{name} = %{version}-%{release}
BuildRequires: gnutls-devel

%package openssl
Summary: TLS protocol support for rsyslog via OpenSSL library
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
BuildRequires: openssl-devel

%package snmp
Summary: SNMP protocol support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: net-snmp-devel

%package udpspoof
Summary: Provides the omudpspoof module
Requires: %{name} = %{version}-%{release}
BuildRequires: libnet-devel

%package omamqp1
Summary: Provides the omamqp1 module
Requires: %{name} = %{version}-%{release}
Requires: cyrus-sasl-lib
Requires: openssl-libs
BuildRequires: cmake
BuildRequires: make
BuildRequires: gcc
BuildRequires: gcc-c++
BuildRequires: cyrus-sasl-devel
BuildRequires: openssl-devel
BuildRequires: python3

%package kafka
Summary: Provides the omkafka module
Requires: %{name} = %{version}-%{release}
BuildRequires: librdkafka-devel

%package mmkubernetes
Summary: Provides the mmkubernetes module
Requires: %{name} = %{version}-%{release}
BuildRequires: libcurl-devel

%package hiredis
Summary: Redis support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: hiredis-devel

%package libdbi
Summary: Libdbi database support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: libdbi-devel

%package rabbitmq
Summary: RabbitMQ support for rsyslog
Requires: %{name} = %{version}-%{release}
BuildRequires: librabbitmq-devel >= 0.2


%description
Rsyslog is an enhanced, multi-threaded syslog daemon. It supports MySQL,
syslog/TCP, RFC 3195, permitted sender lists, filtering on any message part,
and fine grain output format control. It is compatible with stock sysklogd
and can be used as a drop-in replacement. Rsyslog is simple to set up, with
advanced features suitable for enterprise-class, encryption-protected syslog
relay chains.

%description logrotate
This subpackage contains the default logrotate configuration for rsyslog.

%description crypto
This package contains a module providing log file encryption and a
command line tool to process encrypted logs.

%description doc
This subpackage contains documentation for rsyslog.

%description elasticsearch
This module provides the capability for rsyslog to feed logs directly into
Elasticsearch.

%description mmjsonparse
This module provides the capability to recognize and parse JSON enhanced
syslog messages.

%description mmnormalize
This module provides the capability to normalize log messages via liblognorm.

%description mmaudit
This module provides message modification supporting Linux audit format
in various settings.

%description mmfields
The mmfield module permits to extract fields. Using this module is of special
advantage if a field-based log format is to be processed, like for example CEF
and either a large number of fields is needed or a specific field is used multiple
times inside filters.

%description mmsnmptrapd
This message modification module takes messages generated from snmptrapd and
modifies them so that they look like they originated from the read originator.

%description mysql
The rsyslog-mysql package contains a dynamic shared object that will add
MySQL database support to rsyslog.

%description pgsql
The rsyslog-pgsql package contains a dynamic shared object that will add
PostgreSQL database support to rsyslog.

%description gssapi
The rsyslog-gssapi package contains the rsyslog plugins which support GSSAPI
authentication and secure connections. GSSAPI is commonly used for Kerberos
authentication.

%description relp
The rsyslog-relp package contains the rsyslog plugins that provide
the ability to receive syslog messages via the reliable RELP
protocol.

%description gnutls
The rsyslog-gnutls package contains the rsyslog plugins that provide the
ability to send and receive syslog messages via TCP or RELP using TLS
encryption via GnuTLS library. For details refer to rsyslog doc on imtcp
and omfwd modules.

%description openssl
The rsyslog-openssl package contains the rsyslog plugins that provide the
ability to send and receive syslog messages via TCP or RELP using TLS
encryption via OpenSSL library. For details refer to rsyslog doc on imtcp
and omfwd modules.

%description snmp
The rsyslog-snmp package contains the rsyslog plugin that provides the
ability to send syslog messages as SNMPv1 and SNMPv2c traps.

%description udpspoof
This module is similar to the regular UDP forwarder, but permits to
spoof the sender address. Also, it enables to circle through a number
of source ports.

%description omamqp1
The omamqp1 output module can be used to send log messages via an AMQP
1.0-compatible messaging bus.

%description kafka
The rsyslog-kafka package provides module for Apache Kafka output.

%description mmkubernetes
The rsyslog-mmkubernetes package provides module for adding kubernetes
container metadata.

%description hiredis
This module provides output to Redis.

%description libdbi
This module supports a large number of database systems via
libdbi. Libdbi abstracts the database layer and provides drivers for
many systems. Drivers are available via the libdbi-drivers project.

%description rabbitmq
This module allows rsyslog to send messages to a RabbitMQ server.

%prep
# set up rsyslog-doc sources
%setup -q -a 1 -T -c
rm -r LICENSE README.md source build/objects.inv
mv build doc
# set up rsyslog sources
%setup -q -D
# Unpack qpid-proton
%setup -q -D -T -b 6
pushd ..
%patch0 -p1 -b .openssl-compatibility
popd
%patch1 -p1 -b .libcap-ng

%build
export CFLAGS="$RPM_OPT_FLAGS -fpic"
# build the proton first
(
	cd %{_builddir}/qpid-proton-0.34.0

	# Need ENABLE_FUZZ_TESTING=NO to avoid a link failure
	# Find python include dir and python library from
	# https://stackoverflow.com/questions/24174394/cmake-is-not-able-to-find-python-libraries
	%cmake .. \
		-DBUILD_BINDINGS="" \
		-DBUILD_STATIC_LIBS=YES \
		-DENABLE_FUZZ_TESTING=NO \
		-DPYTHON_INCLUDE_DIR=$(python3 -c "from distutils.sysconfig import get_python_inc; print(get_python_inc())")  \
		-DPYTHON_LIBRARY=$(python3 -c "import distutils.sysconfig as sysconfig; print(sysconfig.get_config_var('LIBDIR'))") \
		-DCMAKE_AR="/usr/bin/gcc-ar" -DCMAKE_NM="/usr/bin/gcc-nm" -DCMAKE_RANLIB="/usr/bin/gcc-ranlib"
	%cmake_build
)

export CFLAGS="$RPM_OPT_FLAGS -fpie"
export LDFLAGS="-pie -Wl,-z,relro -Wl,-z,now"

# the hiredis-devel package doesn't provide a pkg-config file
export HIREDIS_CFLAGS=-I/usr/include/hiredis
export HIREDIS_LIBS="-L%{_libdir} -lhiredis"
sed -i 's/%{version}/%{version}-%{release}/g' configure.ac
autoreconf -if
%configure \
	--prefix=/usr \
	--disable-static \
	--disable-testbench \
	--enable-clickhouse \
	--enable-imdocker \
	--enable-improg \
        --enable-libcap-ng \
	--enable-libdbi \
	--enable-omhiredis \
	--enable-omrabbitmq \
	--enable-omamqp1 PROTON_LIBS="%{_builddir}/qpid-proton-0.34.0/%{__cmake_builddir}/c/libqpid-proton-core-static.a %{_builddir}/qpid-proton-0.34.0/%{__cmake_builddir}/c/libqpid-proton-proactor-static.a %{_builddir}/qpid-proton-0.34.0/%{__cmake_builddir}/c/libqpid-proton-static.a -lssl -lsasl2 -lcrypto" PROTON_CFLAGS="-I%{_builddir}/qpid-proton-0.34.0/%{__cmake_builddir}/c/include" \
	--enable-elasticsearch \
	--enable-generate-man-pages \
	--enable-gnutls \
	--enable-openssl \
	--enable-gssapi-krb5 \
	--enable-imfile \
	--enable-imjournal \
	--enable-imkafka \
        --enable-omkafka \
	--enable-impstats \
	--enable-imptcp \
	--enable-mail \
	--enable-mmanon \
	--enable-mmaudit \
	--enable-mmcount \
	--enable-mmfields \
	--enable-mmkubernetes \
	--enable-mmjsonparse \
	--enable-mmnormalize \
	--enable-mmsnmptrapd \
	--enable-mmutf8fix \
	--enable-mysql \
	--enable-omhttp \
	--enable-omjournal \
	--enable-omprog \
	--enable-omstdout \
	--enable-omudpspoof \
	--enable-omuxsock \
	--enable-pgsql \
	--enable-pmaixforwardedfrom \
	--enable-pmcisconames \
	--enable-pmlastmsg \
	--enable-pmsnare \
	--enable-relp \
	--enable-snmp \
	--enable-unlimited-select \
	--enable-usertools 

%make_build

%check
%make_build check

%install
%make_install

install -d -m 755 %{buildroot}%{_sysconfdir}/sysconfig
install -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
install -d -m 755 %{buildroot}%{_unitdir}
install -d -m 755 %{buildroot}%{_sysconfdir}/rsyslog.d
install -d -m 700 %{buildroot}%{rsyslog_statedir}
install -d -m 700 %{buildroot}%{rsyslog_pkidir}
install -d -m 755 %{buildroot}%{rsyslog_docdir}/html

install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/rsyslog.conf
install -p -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/rsyslog
install -p -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/logrotate.d/rsyslog
install -p -m 644 %{SOURCE5} %{buildroot}%{_unitdir}/rsyslog.service
install -p -m 644 plugins/ommysql/createDB.sql %{buildroot}%{rsyslog_docdir}/mysql-createDB.sql
install -p -m 644 plugins/ompgsql/createDB.sql %{buildroot}%{rsyslog_docdir}/pgsql-createDB.sql
dos2unix tools/recover_qi.pl
install -p -m 644 tools/recover_qi.pl %{buildroot}%{rsyslog_docdir}/recover_qi.pl
install -p -m 644 contrib/mmkubernetes/*.rulebase %{buildroot}%{rsyslog_docdir}
# extract documentation
cp -r doc/* %{buildroot}%{rsyslog_docdir}/html
# imdiag and liboverride is only used for testing
rm -f %{buildroot}%{_libdir}/rsyslog/imdiag.so
rm -f %{buildroot}%{_libdir}/rsyslog/liboverride_gethostname.so

%generate_compatibility_deps

%post
for n in /var/log/{messages,secure,maillog,spooler}
do
	[ -f $n ] && continue
	umask 066 && touch $n
done
%systemd_post rsyslog.service

%preun
%systemd_preun rsyslog.service

%postun
%systemd_postun_with_restart rsyslog.service

%files
%dir %{abidir}
%license COPYING*
%doc AUTHORS ChangeLog README.md
%{rsyslog_docdir}
%exclude %{rsyslog_docdir}/html
%exclude %{rsyslog_docdir}/mysql-createDB.sql
%exclude %{rsyslog_docdir}/pgsql-createDB.sql
%dir %{_libdir}/rsyslog
%dir %{_sysconfdir}/rsyslog.d
%dir %{rsyslog_statedir}
%dir %{rsyslog_pkidir}
%{_sbindir}/rsyslogd
%{_mandir}/man5/rsyslog.conf.5*
%{_mandir}/man8/rsyslogd.8*
%{_unitdir}/rsyslog.service
%config(noreplace) %{_sysconfdir}/rsyslog.conf
%config(noreplace) %{_sysconfdir}/sysconfig/rsyslog
# plugins
%{_libdir}/rsyslog/fmhash.so
%{_libdir}/rsyslog/fmhttp.so
%{_libdir}/rsyslog/imfile.so
%{_libdir}/rsyslog/imjournal.so
%{_libdir}/rsyslog/imklog.so
%{_libdir}/rsyslog/immark.so
%{_libdir}/rsyslog/impstats.so
%{_libdir}/rsyslog/imptcp.so
%{_libdir}/rsyslog/imtcp.so
%{_libdir}/rsyslog/imudp.so
%{_libdir}/rsyslog/imuxsock.so
%{_libdir}/rsyslog/lmnet.so
%{_libdir}/rsyslog/lmnetstrms.so
%{_libdir}/rsyslog/lmnsd_ptcp.so
%{_libdir}/rsyslog/lmregexp.so
%{_libdir}/rsyslog/lmtcpclt.so
%{_libdir}/rsyslog/lmtcpsrv.so
%{_libdir}/rsyslog/lmzlibw.so
%{_libdir}/rsyslog/mmanon.so
%{_libdir}/rsyslog/mmcount.so
%{_libdir}/rsyslog/mmexternal.so
%{_libdir}/rsyslog/mmutf8fix.so
%{_libdir}/rsyslog/omhttp.so
%{_libdir}/rsyslog/omjournal.so
%{_libdir}/rsyslog/ommail.so
%{_libdir}/rsyslog/omprog.so
%{_libdir}/rsyslog/omstdout.so
%{_libdir}/rsyslog/omtesting.so
%{_libdir}/rsyslog/omuxsock.so
%{_libdir}/rsyslog/pmaixforwardedfrom.so
%{_libdir}/rsyslog/pmcisconames.so
%{_libdir}/rsyslog/pmlastmsg.so
%{_libdir}/rsyslog/pmsnare.so
%{_libdir}/rsyslog/imdocker.so
%{_libdir}/rsyslog/improg.so
%{_libdir}/rsyslog/omclickhouse.so
%{abidir}/fm*.dump
%{abidir}/im*.dump
%{abidir}/lm*.dump
%{abidir}/mm*.dump
%{abidir}/om*.dump
%{abidir}/pm*.dump

%files logrotate
%config(noreplace) %{_sysconfdir}/logrotate.d/rsyslog

%files crypto
%{_bindir}/rscryutil
%{_mandir}/man1/rscryutil.1*
%{_libdir}/rsyslog/lmcry_gcry.so

%files doc
%doc %{rsyslog_docdir}/html

%files elasticsearch
%{_libdir}/rsyslog/omelasticsearch.so

%files mmaudit
%{_libdir}/rsyslog/mmaudit.so

%files mmfields
%{_libdir}/rsyslog/mmfields.so

%files mmjsonparse
%{_libdir}/rsyslog/mmjsonparse.so

%files mmnormalize
%{_libdir}/rsyslog/mmnormalize.so

%files mmsnmptrapd
%{_libdir}/rsyslog/mmsnmptrapd.so

%files mysql
%doc %{rsyslog_docdir}/mysql-createDB.sql
%{_libdir}/rsyslog/ommysql.so

%files pgsql
%doc %{rsyslog_docdir}/pgsql-createDB.sql
%{_libdir}/rsyslog/ompgsql.so

%files gssapi
%{_libdir}/rsyslog/lmgssutil.so
%{_libdir}/rsyslog/imgssapi.so
%{_libdir}/rsyslog/omgssapi.so

%files relp
%{_libdir}/rsyslog/imrelp.so
%{_libdir}/rsyslog/omrelp.so

%files gnutls
%{_libdir}/rsyslog/lmnsd_gtls.so

%files openssl
%{_libdir}/rsyslog/lmnsd_ossl.so

%files snmp
%{_libdir}/rsyslog/omsnmp.so

%files udpspoof
%{_libdir}/rsyslog/omudpspoof.so

%files omamqp1
%{_libdir}/rsyslog/omamqp1.so

%files kafka
%{_libdir}/rsyslog/imkafka.so
%{_libdir}/rsyslog/omkafka.so

%files mmkubernetes
%{_libdir}/rsyslog/mmkubernetes.so
%doc %{rsyslog_docdir}/k8s_filename.rulebase
%doc %{rsyslog_docdir}/k8s_container_name.rulebase

%files hiredis
%{_libdir}/rsyslog/omhiredis.so

%files libdbi
%{_libdir}/rsyslog/omlibdbi.so

%files rabbitmq
%{_libdir}/rsyslog/omrabbitmq.so

%changelog
* Sat Mar 04 2023 Funda Wang <fundawang@yeah.net> - 8.2212.0-2
- Update patches
- Rebuild for new libpq

* Wed Jan 04 2023 happy_orange <songnannan@linux.alibaba.com> - 8.2212.0-1
- update to 8.2212.0

* Wed Nov 02 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 8.2112.0-3
- optimise spec file

* Mon Jun 13 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 8.2112.0-2
- disable mongodb build, since we do not provide mongodb

* Fri Mar 11 2022 zhang xianting <zhangxianting@uniontech.com> - 8.2112.0-1
- Initial build for Anolis v23
